%expl RK on Toda lattice
clear all

global h n L_0 U_old

n=3;
Tfin = 100;
disp_step = 10;


L_0 = zeros(n,n);
%for n=3
%define upper triang. part:
L_0(1,1) = 3/4;
L_0(1,2) = (1/2)*exp(-1/2);
L_0(1,3) = (1/2)*exp(-1);
L_0(2,2) = -1/2;
L_0(2,3) = (1/2)*exp(3/2);
L_0(3,3) = -1/4;
%for symmetric L_0:
for i=2:n
    for j=1:i-1
        L_0(i,j) = L_0(j,i);
    end
end


L_0 = reshape(L_0,n^2,1);
t_vec = [0:disp_step:Tfin];

[time,L] = ode45(@toda_lattice,t_vec,L_0);
sigma = [];
for k=1:length(t_vec) 
    L_mat = reshape(L(k,:),n,n);
   %sigma(k,:) = eig(L_mat);
    sigma = [sigma;eig(L_mat)'];
end


figure;
hold on
for k=1:n
    plot(t_vec,sigma(:,k));
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%implicit midpoint
clear L

h = 0.1;
U_0 = eye(n);

L_0 = reshape(L_0,n,n);

Nsteps = floor(Tfin/h);
U_old = U_0;
Nstep_eig = floor(disp_step/h);

m=1;
%sigma2(m,:) = eig(L_0);
sigma2 = eig(L_0);
ortho(m) = 0;

for k=1:Nsteps
    
    U = fsolve(@NL_equ,U_old);
    sigma=[];
    if(mod(k,Nstep_eig)==0)
        L = U*L_0*transpose(U);
        ortho(m) = norm(eye(n)-U*transpose(U));
       %sigma2(m,:) = eig(L);
        sigma2 = [sigma2;eig(L)];
        m=m+1
    end
end

hold on
for k=1:n
    plot(t_vec(2:11),sigma2(:,k),'r');
end


%!DSPAM:438212db243571540237419!
